com.fasterxml.jackson.databind.jsontype.impl

## Class AsPropertyTypeSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.TypeSerializer
  - - com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase
    - - com.fasterxml.jackson.databind.jsontype.impl.AsArrayTypeSerializer
      - - com.fasterxml.jackson.databind.jsontype.impl.AsPropertyTypeSerializer

-     public class AsPropertyTypeSerializer
      extends AsArrayTypeSerializer

  Type serializer that preferably embeds type information as an additional JSON Object property, if possible (when resulting serialization would use JSON Object). If this is not possible (for JSON Arrays, scalars), uses a JSON Array wrapper (similar to how `JsonTypeInfo.As.WRAPPER_ARRAY` always works) as a fallback.
  Author:
    tatus

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `_typePropertyName`

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `_idResolver, _property`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsPropertyTypeSerializer(TypeIdResolver idRes, BeanProperty property, String propName)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AsPropertyTypeSerializer` | `forProperty(BeanProperty prop)` Method called to create contextual version, to be used for values of given property.
    `String` | `getPropertyName()` Name of property that contains type information, if property-based inclusion is used.
    `JsonTypeInfo.As` | `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
    `void` | `writeCustomTypePrefixForObject(Object value, JsonGenerator jgen, String typeId)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`.
    `void` | `writeCustomTypeSuffixForObject(Object value, JsonGenerator jgen, String typeId)`
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator jgen)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar).
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator jgen, Class<?> type)` Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypeSuffixForObject(Object value, JsonGenerator jgen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`.

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.AsArrayTypeSerializer

      `writeCustomTypePrefixForArray, writeCustomTypePrefixForScalar, writeCustomTypeSuffixForArray, writeCustomTypeSuffixForScalar, writeTypePrefixForArray, writeTypePrefixForArray, writeTypePrefixForScalar, writeTypePrefixForScalar, writeTypeSuffixForArray, writeTypeSuffixForScalar`

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `getTypeIdResolver, idFromValue, idFromValueAndType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _typePropertyName

          protected final String _typePropertyName

  - ### Constructor Detail

    - #### AsPropertyTypeSerializer

          public AsPropertyTypeSerializer(TypeIdResolver idRes,
                                  BeanProperty property,
                                  String propName)

  - ### Method Detail

    - #### forProperty

          public AsPropertyTypeSerializer forProperty(BeanProperty prop)

      Description copied from class: `TypeSerializer`
      Method called to create contextual version, to be used for values of given property. This may be the type itself (as is the case for bean properties), or values contained (for `Collection` or `Map` valued properties).
      Overrides:
        `forProperty` in class `AsArrayTypeSerializer`

    - #### getPropertyName

          public String getPropertyName()

      Description copied from class: `TypeSerializer`
      Name of property that contains type information, if property-based inclusion is used.
      Overrides:
        `getPropertyName` in class `TypeSerializerBase`

    - #### getTypeInclusion

          public JsonTypeInfo.As getTypeInclusion()

      Description copied from class: `TypeSerializer`
      Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
      Overrides:
        `getTypeInclusion` in class `AsArrayTypeSerializer`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar). This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Overrides:
        `writeTypePrefixForObject` in class `AsArrayTypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `jgen` - Generator to use for writing type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator jgen,
                                      Class<?> type)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForObject` in class `AsArrayTypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypeSuffixForObject

          public void writeTypeSuffixForObject(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`. It needs to write closing END_OBJECT marker, and any other decoration that needs to be matched.
      Overrides:
        `writeTypeSuffixForObject` in class `AsArrayTypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeCustomTypePrefixForObject

          public void writeCustomTypePrefixForObject(Object value,
                                            JsonGenerator jgen,
                                            String typeId)
                                              throws IOException,
                                                     JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`. This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Overrides:
        `writeCustomTypePrefixForObject` in class `AsArrayTypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `jgen` - Generator to use for writing type information
        `typeId` - Exact type id to use
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeCustomTypeSuffixForObject

          public void writeCustomTypeSuffixForObject(Object value,
                                            JsonGenerator jgen,
                                            String typeId)
                                              throws IOException,
                                                     JsonProcessingException

      Overrides:
        `writeCustomTypeSuffixForObject` in class `AsArrayTypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

Copyright © 2012-2013 FasterXML. All Rights Reserved.